import { ModuleDescription, ModuleData, AdventureImage, CaptionImage } from "./IAdventure";
import { ModuleScene } from "./ModuleScene";
import { PdfData } from "../parse";
import { PageLayoutEmitFunction, PageLayout } from "./PageLayouts";
import * as EC from './extinctioncurse';
import { sentenceCase } from "./core";

const adventureModule : ModuleDescription = {
    prefix: "extinction-curse4",
    fullName: "Extinction Curse - Siege of the Dinosaurs",
    detect: (pdf: PdfData) => {
        return pdf.textDetails.some(t => t.text.trim() == 'EXTINCTION CURSE: SIEGE OF THE DINOSAURS' && t.fontId == 'Gin-Regular:12');
    },
    extractDetails: EC.extractDetails,
    detectPageLayout: EC.detectPageLayout,
    pages: [
        // chapter 1
        new EC.ChapterHeadingPageLayout(6),
        new EC.RightSingleColumnWithSidebar(7),
        new EC.LeftTwoColumnWithMap(8, 340),
        new EC.RightTwoColumn(9),
        new EC.LeftTwoColumnWithLeftCutout(10, 320),
        new EC.RightTwoColumn(11),
        new EC.LeftTwoColumn(12),
        new EC.RightTwoColumn(13),
        new EC.LeftTwoColumn(14),
        new EC.RightTwoColumn(15),
        new EC.LeftTwoColumnWithMap(16, 340),
        new EC.RightTwoColumn(17),
        new EC.LeftTwoColumn(18),
        new EC.RightTwoColumn(19),
        new EC.LeftTwoColumn(20),
        new EC.RightTwoColumn(21),
        new EC.LeftTwoColumn(22),
        new EC.RightTwoColumn(23),
        new EC.LeftTwoColumn(24),
        new EC.RightTwoColumn(25),

        // chapter 2
        new EC.ChapterHeadingPageLayout(26),
        new EC.RightSingleColumnWithSidebar(27),
        new EC.LeftTwoColumn(28),
        new EC.RightTwoColumnWithRightCutout(29, 570),
        new EC.LeftTwoColumn(30),
        new EC.RightTwoColumn(31),
        // map on 32
        new EC.RightTwoColumnWithRightCutout(33, 340),
        new EC.LeftTwoColumn(34),
        new EC.RightTwoColumn(35),
        new EC.LeftTwoColumn(36),
        new EC.RightTwoColumn(37),
        new EC.LeftTwoColumn(38),
        new EC.RightTwoColumn(39),
        new EC.LeftTwoColumn(40),
        new EC.RightTwoColumn(41),
        new EC.LeftTwoColumn(42),
        new EC.RightTwoColumn(43),
        
        // chapter 3
        new EC.ChapterHeadingPageLayout(44),
        new EC.RightSingleColumnWithSidebar(45),
        new EC.LeftTwoColumn(46),
        new EC.RightTwoColumn(47),
        new EC.LeftTwoColumn(48),
        new EC.RightTwoColumn(49),
        new EC.LeftTwoColumn(50),
        new EC.RightTwoColumn(51),
        new EC.LeftTwoColumn(52),
        new EC.RightTwoColumn(53),
        new EC.LeftTwoColumnWithMap(54, 340),
        new EC.RightTwoColumn(55),
        new EC.LeftTwoColumn(56),
        new EC.RightTwoColumn(57),
        new EC.LeftTwoColumn(58),
        new EC.RightTwoColumn(59),
        new EC.LeftTwoColumn(60),
        new EC.RightTwoColumn(61),
        
        // appendix 1
        new EC.RightChapterHeadingPageLayout(63),
        new EC.LeftTwoColumnWithMap(64, 340),
        new EC.RightTwoColumn(65),
        new EC.LeftTwoColumn(66),
        new EC.RightTwoColumn(67),
        
        // appendix 2
        new EC.RightChapterHeadingPageLayout(69),
        new EC.LeftTwoColumn(70),
        new EC.RightTwoColumn(71),
        new EC.LeftTwoColumn(72),
        new EC.RightTwoColumn(73),
        
        // adventure toolbox
        new EC.RightChapterHeadingPageLayout(75),
        new EC.LeftTwoColumn(76),
        new EC.RightTwoColumn(77),
        new EC.LeftTwoColumn(78),
        new EC.RightSingleColumnWithSidebar(79),
        new EC.LeftSingleColumnWithSidebar(80),
        new EC.RightSingleColumnWithSidebar(81),
        new EC.LeftSingleColumnWithSidebar(82),
        new EC.RightSingleColumnWithSidebar(83),
        new EC.LeftSingleColumnWithSidebar(84),
        new EC.RightSingleColumnWithSidebar(85),
        new EC.LeftSingleColumnWithSidebar(86),
        new EC.RightSingleColumnWithSidebar(87),
        new EC.ChapterHeadingPageLayout(88),
        new EC.RightTwoColumn(89),
        new EC.ChapterHeadingPageLayout(90),
        new EC.RightTwoColumn(91),
        new EC.ChapterHeadingPageLayout(92),
        new EC.RightTwoColumn(93),
    ],
    scenes: [
        new ModuleScene({
            name: 'map1a',
            nameInfo: { x: 16, y: 758.8362 },
            nameFn: name => sentenceCase(name),
            page: 8, width: 1259, height: 880,
            cropLeft: 0, cropRight: 650, cropTop: 0, cropBottom: 481,
            imageLeft: 7, imageRight: 629, imageCols: 26,
            imageTop: 2, imageBottom: 458, imageRows: 18,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map1b',
            nameInfo: { x: 324, y: 758.8362 },
            nameFn: name => sentenceCase(name),
            page: 8, width: 1259, height: 880,
            cropLeft: 656, cropRight: 1259, cropTop: 0, cropBottom: 880,
            imageLeft: 677, imageRight: 1252, imageCols: 24,
            imageTop: 2, imageBottom: 863, imageRows: 34,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map1c',
            nameInfo: { x: 16, y: 534.3362 },
            nameFn: name => sentenceCase(name),
            page: 8, width: 1259, height: 880,
            cropLeft: 0, cropRight: 650, cropTop: 486, cropBottom: 880,
            imageLeft: 7, imageRight: 629, imageCols: 26,
            imageTop: 508, imageBottom: 863, imageRows: 14,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map2',
            nameInfo: { x: 16, y: 758.8362 },
            nameFn: name => sentenceCase(name),
            page: 16, width: 1259, height: 880,
            imageLeft: 16, imageRight: 1248, imageCols: 50,
            imageTop: 4, imageBottom: 868, imageRows: 33,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map3',
            nameInfo: { x: 16, y: 760.3362 },
            nameFn: name => sentenceCase(name),
            page: 32, width: 1261, height: 1637,
            imageLeft: 22, imageRight: 1194, imageCols: 39,
            imageTop: 50, imageBottom: 1553, imageRows: 50,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map4',
            nameInfo: { x: 299, y: 694.8362 },
            nameFn: name => sentenceCase(name),
            page: 47, width: 441, height: 303,
            imageLeft: 6, imageRight: 423, imageCols: 21,
            imageTop: 3, imageBottom: 280, imageRows: 14,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map5',
            nameInfo: { x: 104, y: 694.8362 },
            nameFn: name => sentenceCase(name),
            page: 48, width: 438, height: 305,
            imageLeft: 20, imageRight: 413, imageCols: 17,
            imageTop: 25, imageBottom: 279, imageRows: 11,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map6',
            nameInfo: { x: 333.5, y: 693.8362 },
            nameFn: name => sentenceCase(name),
            page: 50, width: 441, height: 653,
            imageLeft: 4, imageRight: 421, imageCols: 18,
            imageTop: 4, imageBottom: 628, imageRows: 27,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map7',
            nameInfo: { x: 332.5, y: 693.8362 },
            nameFn: name => sentenceCase(name),
            page: 52, width: 439, height: 730,
            imageLeft: 24, imageRight: 413, imageCols: 14,
            imageTop: 28, imageBottom: 720, imageRows: 25,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map8',
            nameInfo: { x: 300, y: 694.6681 },
            nameFn: name => sentenceCase(name),
            page: 53, width: 441, height: 730,
            imageLeft: 38, imageRight: 404, imageCols: 11,
            imageTop: 32, imageBottom: 699, imageRows: 20,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map9',
            nameInfo: { x: 16, y: 758.8362 },
            nameFn: name => sentenceCase(name),
            page: 54, width: 1259, height: 880,
            imageLeft: 12, imageRight: 1241, imageCols: 41,
            imageTop: 12, imageBottom: 872, imageRows: 27,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map10',
            nameInfo: { x: 74, y: 693.8362 },
            nameFn: name => sentenceCase(name),
            page: 61, width: 440, height: 730,
            imageLeft: 32, imageRight: 419, imageCols: 13,
            imageTop: 28, imageBottom: 710, imageRows: 23,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map11',
            nameInfo: { x: 16, y: 758.8362 },
            nameFn: name => sentenceCase(name),
            page: 64, width: 1259, height: 880,
            gridType: 'gridless',
            imageLeft: 0, imageRight: 1000, imageCols: 10,
            imageTop: 0, imageBottom: 1000, imageRows: 10,
            globalLight: true,
        }),
    ],
    journals: [
        new AdventureImage({ name: 'journal1', page: 2, width: 589, height: 809, index: 0 }),
        new AdventureImage({ name: 'journal2', page: 2, width: 589, height: 809, index: 1 }),
        new AdventureImage({ name: 'journal3', page: 2, width: 589, height: 809, index: 2 }),
        new AdventureImage({ name: 'journal4', page: 2, width: 589, height: 809, index: 3 }),
        new AdventureImage({ name: 'journal5', page: 2, width: 589, height: 809, index: 4 }),
        new AdventureImage({ name: 'journal6', page: 2, width: 589, height: 809, index: 5 }),
        new AdventureImage({ name: 'journal7', page: 4, width: 1261, height: 1637 }),
        new AdventureImage({ name: 'journal8', page: 6, width: 1259, height: 805 }),
        new AdventureImage({ name: 'journal9', page: 26, width: 1259, height: 805 }),
        new AdventureImage({ name: 'journal10', page: 44, width: 1261, height: 805 }),
        new CaptionImage({ name: 'journal11', page: 59, width: 793, height: 1073 }),
        new AdventureImage({ name: 'journal12', page: 62, width: 1261, height: 1637 }),
        new AdventureImage({ name: 'journal13', page: 68, width: 1261, height: 1637 }),
        new AdventureImage({ name: 'journal14', page: 70, width: 935, height: 978 }),
        new AdventureImage({ name: 'journal15', page: 73, width: 909, height: 645 }),
        new AdventureImage({ name: 'journal16', page: 74, width: 1261, height: 1636 }),

        new CaptionImage({ name: 'npc1', page: 9, width: 564, height: 543 }),
        new CaptionImage({ name: 'npc2', page: 11, width: 578, height: 577 }),
        new CaptionImage({ name: 'npc3', page: 13, width: 941, height: 1201 }),
        new CaptionImage({ name: 'npc4', page: 17, width: 917, height: 661 }),
        new CaptionImage({ name: 'npc5', page: 18, width: 894, height: 1259 }),
        new CaptionImage({ name: 'npc6', page: 19, width: 602, height: 1080 }),
        new CaptionImage({ name: 'npc7', page: 21, width: 895, height: 1140 }),
        new CaptionImage({ name: 'npc8', page: 25, width: 825, height: 1586 }),
        new CaptionImage({ name: 'npc9', page: 30, width: 436, height: 616 }),
        new CaptionImage({ name: 'npc10', page: 31, width: 453, height: 594 }),
        new CaptionImage({ name: 'npc11', page: 34, width: 482, height: 482 }),
        new CaptionImage({ name: 'npc12', page: 35, width: 759, height: 1075 }),
        new CaptionImage({ name: 'npc13', page: 36, width: 960, height: 1244 }),
        new CaptionImage({ name: 'npc14', page: 39, width: 851, height: 913 }),
        new CaptionImage({ name: 'npc15', page: 40, width: 892, height: 1190 }),
        new CaptionImage({ name: 'npc16', page: 41, width: 773, height: 986 }),
        new CaptionImage({ name: 'npc17', page: 43, width: 868, height: 1119 }),
        new CaptionImage({ name: 'npc18', page: 49, width: 924, height: 920 }),
        new CaptionImage({ name: 'npc19', page: 52, width: 824, height: 678 }),
        new CaptionImage({ name: 'npc20', page: 56, width: 880, height: 1285 }),
        new CaptionImage({ name: 'npc21', page: 58, width: 801, height: 1236 }),
        new CaptionImage({ name: 'npc22', page: 60, width: 453, height: 590 }),
        new CaptionImage({ name: 'npc23', page: 65, width: 566, height: 714 }),
        new CaptionImage({ name: 'npc24', page: 66, width: 447, height: 548 }),
        new CaptionImage({ name: 'npc25', page: 67, width: 443, height: 589 }),
        new CaptionImage({ name: 'npc26', page: 75, width: 865, height: 1028 }),
        new CaptionImage({ name: 'npc27', page: 76, width: 961, height: 1255 }),
        new CaptionImage({ name: 'npc28', page: 77, width: 500, height: 501 }),
        new CaptionImage({ name: 'npc29', page: 78, width: 382, height: 472 }),
        new CaptionImage({ name: 'npc30', page: 78, width: 521, height: 521 }),
        new CaptionImage({ name: 'npc31', page: 79, width: 913, height: 831 }),
        new CaptionImage({ name: 'npc32', page: 81, width: 955, height: 772 }),
        new CaptionImage({ name: 'npc33', page: 82, width: 725, height: 1065 }),
        new CaptionImage({ name: 'npc34', page: 83, width: 713, height: 1049 }),
        new CaptionImage({ name: 'npc35', page: 84, width: 751, height: 1294 }),
        new CaptionImage({ name: 'npc36', page: 85, width: 907, height: 711 }),
        new CaptionImage({ name: 'npc37', page: 86, width: 882, height: 1169 }),
        new CaptionImage({ name: 'npc38', page: 87, width: 901, height: 1088 }),
        new CaptionImage({ name: 'npc39', page: 89, width: 776, height: 1186 }),
        new CaptionImage({ name: 'npc40', page: 91, width: 778, height: 1214 }),
        new CaptionImage({ name: 'npc41', page: 93, width: 978, height: 1315 }),
    ],
    finalize: (moduleData: ModuleData) => {
    }
};

export default adventureModule;